
#ifndef TREES_H
#define TREES_H

void loadTree( char *fn );

typedef struct node_t {
	int ncount;
	int index;
	struct tree_t *tree;
	int *neighbors;
	void *tag;
	int avail[ 4 ];
	char deco;
} node_t;

typedef struct tree_t {
	int N, rest;
	node_t *nodes;
} tree_t;

extern tree_t tree;

typedef struct move_t {
	node_t *node;
	char deco;
} move_t;

#endif

