
#include "tree_lib.h"

int main( int argc, char *argv ) {
	int N = init();
	int i = 1;
	for(;;) {
		int deco = 0;
		for( ; i <= N; ++ i ) {
			if( decoration( i ) != ' ' )
				continue;
			char avail[] = "ABDS";
			for( int j = 1; j <= neighbor_count( i ); ++j ) {
				char d = decoration( neighbor( i, j ) );
				for( int k = 0; k < 4; ++k ) {
					if( avail[ k ] == d ) {
						avail[ k ] = 0;
						break;
					}
				}
			}
			char d = 0;
			for( int j = 0; j < 4; ++ j ) {
				if( avail[ j ] ) {
					d = avail[ j ];
					break;
				}
			}
			if( d ) {
				decorate( i, d );
				deco = 1;
				break;
			}
		}
		if( !deco )
			decorate( 1, 'A' );
		enemy();
	}
}
